/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.applications.sampleApplication;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import javax.swing.JCheckBox;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;


/**
 *
 * @author know
 */

public class ModuleActivationPanel extends javax.swing.JPanel
{

    /**
     * Creates new form ModuleActivationPanel
     */
    public ModuleActivationPanel()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        showIsoBox = new JCheckBox();
        showSliceBox = new JCheckBox();
        showIsolinesBox = new JCheckBox();
        showGlyphsBox = new JCheckBox();

        setLayout(new GridLayout(4, 0));

        showIsoBox.setSelected(true);
        showIsoBox.setText("show isosurface");
        showIsoBox.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                showIsoBoxActionPerformed(evt);
            }
        });
        add(showIsoBox);

        showSliceBox.setSelected(true);
        showSliceBox.setText("show slice");
        showSliceBox.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                showSliceBoxActionPerformed(evt);
            }
        });
        add(showSliceBox);

        showIsolinesBox.setSelected(true);
        showIsolinesBox.setText("show isolines on slice");
        showIsolinesBox.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                showIsolinesBoxActionPerformed(evt);
            }
        });
        add(showIsolinesBox);

        showGlyphsBox.setSelected(true);
        showGlyphsBox.setText("show glyphs");
        showGlyphsBox.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                showGlyphsBoxActionPerformed(evt);
            }
        });
        add(showGlyphsBox);
    }// </editor-fold>//GEN-END:initComponents

    private void showIsoBoxActionPerformed(ActionEvent evt)//GEN-FIRST:event_showIsoBoxActionPerformed
    {//GEN-HEADEREND:event_showIsoBoxActionPerformed
        fireStateChanged();
    }//GEN-LAST:event_showIsoBoxActionPerformed

    private void showSliceBoxActionPerformed(ActionEvent evt)//GEN-FIRST:event_showSliceBoxActionPerformed
    {//GEN-HEADEREND:event_showSliceBoxActionPerformed
        fireStateChanged();
    }//GEN-LAST:event_showSliceBoxActionPerformed

    private void showIsolinesBoxActionPerformed(ActionEvent evt)//GEN-FIRST:event_showIsolinesBoxActionPerformed
    {//GEN-HEADEREND:event_showIsolinesBoxActionPerformed
        fireStateChanged();
    }//GEN-LAST:event_showIsolinesBoxActionPerformed

    private void showGlyphsBoxActionPerformed(ActionEvent evt)//GEN-FIRST:event_showGlyphsBoxActionPerformed
    {//GEN-HEADEREND:event_showGlyphsBoxActionPerformed
        fireStateChanged();
    }//GEN-LAST:event_showGlyphsBoxActionPerformed

    /**
     * Utility field holding list of ChangeListeners.
     */
    protected transient ArrayList<ChangeListener> changeListenerList = new ArrayList<>();

    /**
     * Registers ChangeListener to receive events.
     *
     * @param listener The listener to register.
     */
    public synchronized void addChangeListener(ChangeListener listener)
    {
        changeListenerList.add(listener);
    }

    /**
     * Removes ChangeListener from the list of listeners.
     *
     * @param listener The listener to remove.
     */
    public synchronized void removeChangeListener(ChangeListener listener)
    {
        changeListenerList.remove(listener);
    }

    /**
     * Notifies all registered listeners about the event.
     *
     */
    protected void fireStateChanged()
    {
        ChangeEvent e = new ChangeEvent(this);
        for (ChangeListener listener : changeListenerList)
            listener.stateChanged(e);
    }
    
    public boolean showSlice()
    {
        return showSliceBox.isSelected();
    }
    
    public boolean showGlyphs()
    {
        return showGlyphsBox.isSelected();
    }
    
    public boolean showIsolines()
    {
        return showIsolinesBox.isSelected();
    }
    
    public boolean showIsosurface()
    {
        return showIsoBox.isSelected();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected JCheckBox showGlyphsBox;
    protected JCheckBox showIsoBox;
    protected JCheckBox showIsolinesBox;
    protected JCheckBox showSliceBox;
    // End of variables declaration//GEN-END:variables
}
